C*********************************************************************
C
C     PROGRAM xzcont_pt_cl
C
C     x-z平面等値線図作成プログラム(時刻, 条件指定, カラー)
C
C     履歴 1997/07/24 中島健介
C          1997/07/25 小高正嗣
C          1997/07/26 小高正嗣
C          1997/07/26 小高正嗣
C          1998/09/17 小高正嗣
C          1998/10/02 小高正嗣
C          1999/01/10 小高正嗣
C          1999/01/18 小高正嗣
C          1999/01/27 小高正嗣
C          1999/02/04 小高正嗣
C
C*********************************************************************
      program xzcont_pt_cl
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      real cdp                  ! カラートーン刻み
      real tlev1,tlev2          ! カラーレベル
      integer ipat              ! トーン番号
      integer cmax
      parameter ( cmax = 60 )
      real ptmax, ptmin
      parameter ( ptmax = 4.0, ptmin = -4.0 )
C      parameter ( ptmax = 3.0, ptmin = -3.0 )

      real*4 pti(2,cmax+1)
*-----------------------------------------------------
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )
      parameter ( PI = 3.141592D0 ) 

      real*8
     \   zgrid ( -2:nzb ),
     \   temp0 ( -2:nzb ),
     \   tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ),
     \   ppai0 ( -2:nzb ),
     \   pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ),
     \   qvap0 ( -2:nzb )

      real*8
     \     tpot ( -2:nxb, -2:nzb )

      real*4
     \    z0p ( 0:nz ), 
     \    p0p ( 0:nz ),
     \    d0p ( 0:nz ),
     \ temp0p ( 0:nz ),
     \ tpot0p ( 0:nz ),
     \  pai0p ( 0:nz ),
     \ rvap0p ( 0:nz ),
     \ qvap0p ( 0:nz )

      real*4 z0pp( nz+1 )

      real*4 
     \      tpotp ( nx+1, nz+1 ),
     \      tpall ( nx+1, nz+1 ),
     \      tpave ( nz+1 ),
     \      tpdev ( nx+1, nz+1 )

      character*2 mint
      character*2 lt
      character*2 date
      character*17 header

      character*100 dumy
      character CSGI*1

*-----------------------------------------------------
      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als
      close(11)

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      do iz = 0, nz
         z0p(iz)   = zgrid(iz)
         p0p(iz)   = pres0(iz)
         d0p(iz)   = dens0(iz)
         temp0p(iz)= temp0(iz)
         tpot0p(iz)= tpot0(iz)
         pai0p(iz) = ppai0(iz)
         rvap0p(iz)= rvap0(iz)
         qvap0p(iz)= qvap0(iz)
      end do

      do iz = 1, nz+1
         z0pp(iz) = z0p(iz-1) / 1000.0
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv

      call sgpwsn
      read(*,*) iws

      CALL SWISET('IWIDTH',  640)
c      CALL SWISET('IHEIGHT', 540)
      CALL SWISET('IHEIGHT', 300)
      call swlset( 'LDUMP', .TRUE. )

      call gropn(iws)
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call uzfact(0.6)
*
      cdp = (ptmax - ptmin)/cmax

      TLEV2 = ptmin + cdp
      TLEV1 = -10.0
      call uestlv(TLEV1, TLEV2, 30999)

      do i = 2,cmax-1
c      do i = 1,cmax
         TLEV2 =  ptmin + i*cdp 
         TLEV1 =  TLEV2 - cdp
         ipat  = (30+(i-1))*1000 + 999
         call uestlv(TLEV1, TLEV2, IPAT)
      end do
      
      TLEV2 = 10.0
      TLEV1 = ptmax - cdp
      call uestlv(TLEV1, TLEV2, 89999)


      do k=1,cmax+1
        pti(1,k) = ptmin + (k-1)*cdp
        pti(2,k) = ptmin + (k-1)*cdp
      end do

      do it = 1, ite

      read(34) time, ((tpot(ix,iz),ix=-2,nxb), iz=-2,nzb)

      write(0,*) 'reading time = ', time

      if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time

c*** 時刻変換: 秒から LT へ************************************
            time = time + times
            write(date,'(I2.2)') INT( time / day ) + 1

            time = ( time - INT( time / day ) * day ) / hour 

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(lt, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

            header = 'day=' // date // ' ' // 'LT=' // lt // ':' // mint
c**************************************************************

            do iz = 1,nz+1
               do ix = 1, nx+1
                  tpotp(ix,iz) = tpot(ix-1,iz-1)
                  tpall(ix,iz) = tpot(ix-1,iz-1) + tpot0(iz-1)
               end do
            end do
*
            do iz = 1, nz+1
               tpave(iz) = 0.
               do ix = 1,nx+1
                  tpave(iz) = tpave(iz) + tpall(ix,iz) /(nx+1)
               end do
            end do

            do iz = 1,nz+1
               do ix = 1, nx+1
                  tpdev(ix,iz) = tpall(ix,iz) - tpave(iz) 
               end do
            end do

            call grfrm
            call grswnd ( 0.0, 51.2, 0.0, 20.0 )
            call grsvpt ( 0.1, 0.9, 0.10, 0.412 )
            call grstrn (1)
            call uspfit
            call grstrf
            call uwsgya ( z0pp, nz+1 )

            call udpset ( 'rsizet', 0.01 )
            call ussttl ( CSGI(131)
     \           //CSGI(135)//'[K]', 'X[km]', '', 'Z[km]' )
c            call uetone ( tpdev, nx+1, nx+1, nz+1 )
            call uetonf ( tpdev, nx+1, nx+1, nz+1 )
            call usdaxs
            call uxsttl ( 'T', header, 1. )
*
*
C*********************************************************************
C トーンバー
C*********************************************************************
            call grfig
            call uwsgyz( .FALSE. )
            call grswnd( 0.0, 1.0,  ptmin, ptmax )
            call grsvpt( 0.95, 0.98,  0.10,  0.412 )
            call grstrn( 1 )
            call grstrf
            call uetone( pti, 2, 2, cmax+1 )

            call slpvpr( 3 )
            call uyaxdv( 'L', 0.2, 1.0 )

         end if
      end if

      end do

      call grcls

      call FCLOSE

      end
